unit NewAliasDialog;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, Buttons, FileCtrl;

type
  TFormNewAlias = class(TForm)
    edAlias: TEdit;
    lblAlias: TLabel;
    btnOk: TButton;
    btnCancel: TButton;
    Label1: TLabel;
    SpeedButton1: TSpeedButton;
    DriveComboBox1: TDriveComboBox;
    DirectoryListBox1: TDirectoryListBox;
    procedure btnCancelClick(Sender: TObject);
    procedure btnOkClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure SpeedButton1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormNewAlias: TFormNewAlias;

implementation

{$R *.DFM}

uses AliasDialog, dbtables;

procedure TFormNewAlias.btnCancelClick(Sender: TObject);
begin
  ModalResult := mrCancel;
end;

procedure TFormNewAlias.btnOkClick(Sender: TObject);
var
  aList: TStringList;
begin
  if Length(edAlias.Text) > 0 then begin
    aList := TStringList.Create;
    Session.ConfigMode := cmAll;
    Session.GetAliasNames(aList);
    if aList.IndexOf(edAlias.Text) = -1 then
      ModalResult := mrOk
    else
      ShowMessage('The alias '+edAlias.Text+' already exists.');
    {fi}
    Session.ConfigMode := cmPersistent;
    aList.Free;
    end
  else
    ShowMessage('An alias must be specified.');
  {fi}
end;

procedure TFormNewAlias.FormActivate(Sender: TObject);
begin
  edAlias.Text := '';
end;

procedure TFormNewAlias.SpeedButton1Click(Sender: TObject);
var
  aFolder: string;
  sTemp: string;
begin
  if InputQuery('New Folder','Enter name of new subfolder of '+
                DirectoryListBox1.Directory,aFolder) then begin
    sTemp := DirectoryListBox1.Directory;
    if Length(sTemp) = 3 then
      sTemp := sTemp + aFolder
    else
      sTemp := sTemp + '\' + aFolder;
    {fi}
    if FileExists(sTemp+'\NUL') then
      ShowMessage('The folder '+sTemp+' already exists.')
    else begin
      MkDir(sTemp);
      DirectoryListBox1.Directory := sTemp;
      end;
    {fi}
    end;
  {fi}
end;

end.
