unit OpenDbForm;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, FileCtrl;

type
  TformOpenDb = class(TForm)
    btnOpen: TButton;
    btnCancel: TButton;
    DirectoryListBox1: TDirectoryListBox;
    DriveComboBox1: TDriveComboBox;
    Label1: TLabel;
    FileListBox1: TFileListBox;
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
  private
    { Private declarations }
    procedure AppException(Sender: TObject; E: Exception);
    function GetPath: string;
  public
    { Public declarations }
    property DbName: string read GetPath;
  end;

var
  formOpenDb: TformOpenDb;

implementation

{$R *.DFM}

function TformOpenDb.GetPath;
begin
  Result := DirectoryListBox1.Directory;
end;

procedure TformOpenDb.AppException(Sender: TObject; E: Exception);
begin
  if Pos('21',E.Message) > 0 then
    ShowMessage('The drive '+DriveComboBox1.Drive+': is not ready.')
  else
    ShowMessage(E.Message);
  {fi}
end;  { TformOpenDb.AppException }

procedure TformOpenDb.FormActivate(Sender: TObject);
begin
  Application.OnException := AppException;
end;

procedure TformOpenDb.FormDeactivate(Sender: TObject);
begin
  Application.OnException := nil;
end;

end.
