unit TableStructure;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Grids, StdCtrls, Buttons, PrintPrev, ChildWin, ExtCtrls;

type
  TFormStruct = class(TForm)
    StringGrid2: TStringGrid;
    TblName: TEdit;
    Label1: TLabel;
    StringGrid3: TStringGrid;
    btnOk: TBitBtn;
    btnPrint: TBitBtn;
    btnSave: TBitBtn;
    dbType: TEdit;
    Label2: TLabel;
    Panel1: TPanel;
    StaticText1: TStaticText;
    edMSize: TEdit;
    StaticText3: TStaticText;
    procedure btnPrintClick(Sender: TObject);
    procedure btnSaveClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
    procedure Setup(aChild: TMDIChild);
  end;

var
  FormStruct: TFormStruct;

implementation

{$R *.DFM}

uses
  Main, IndexDef, Printers, dbvConst, db, Math;

procedure TFormStruct.Setup(aChild: TMDIChild);
var
  Cntr: Integer;
  Limit: Integer;
begin
  with aChild do begin
    TblName.Text := Table1.TableName;
    case dBASEtype of
      Lvl5Type: begin
           dbType.Text := 'dBASE Level 5';
           StringGrid2.ColCount := 4;
         end;
      Lvl7Type: begin
           dbType.Text := 'dBASE Level 7';
           StringGrid2.ColCount := 5;
           StringGrid2.ColWidths[4] := 35;
           StringGrid2.Cells[4,0] := 'Req''d';
         end;
      FoxProType: begin
           dbType.Text := 'Fox Pro';
           StringGrid2.ColCount := 4;
         end;
    end; {case}
    StringGrid2.RowCount := High(TableStructure) + 2;
    StringGrid2.ColWidths[0] := 350;
    StringGrid2.ColWidths[1] := 45;
    StringGrid2.ColWidths[2] := 45;
    StringGrid2.ColWidths[3] := 45;
    StringGrid2.Cells[0,0] := 'Name';
    StringGrid2.Cells[1,0] := 'Type';
    StringGrid2.Cells[2,0] := 'Size';
    StringGrid2.Cells[3,0] := 'Decimal';
    for Cntr := 1 to High(TableStructure) + 1 do
      with TableStructure[Cntr - 1] do begin
        StringGrid2.Cells[0,Cntr] := Name;
        StringGrid2.Cells[1,Cntr] := FieldType;
        StringGrid2.Cells[2,Cntr] := Length;
        StringGrid2.Cells[3,Cntr] := Decimal;
        if (dBASEType = Lvl7Type) then
          StringGrid2.Cells[4,Cntr] := Required;
        {fi}
        end;
      {od with}
    {od for}
    Table1.IndexDefs.Update;
    Limit := Table1.IndexDefs.Count;
    for Cntr := StringGrid3.RowCount-1 downto 1 do
      StringGrid3.Rows[Cntr].Clear;
    {fi}
    StringGrid3.RowCount := Max(2,Limit+1);
    with StringGrid3 do begin
      ColWidths[2] := 40;
      ColWidths[1] := Width - ColWidths[0] - 60;
      Cells[0,0] := 'Index Name';
      Cells[1,0] := 'Index Definition';
      Cells[2,0] := 'Options';
      end;
    {od with}
    for Cntr := 1 to Limit do begin
      StringGrid3.Cells[0,Cntr] := Table1.IndexDefs.Items[Cntr-1].Name;
      if ixExpression in Table1.IndexDefs[Cntr-1].Options then
        StringGrid3.Cells[1,Cntr] := Table1.IndexDefs.Items[Cntr-1].Expression
      else
        StringGrid3.Cells[1,Cntr] := Table1.IndexDefs.Items[Cntr-1].Fields;
      {fi}
      StringGrid3.Cells[2,Cntr] := GetOptions(Table1.IndexDefs[Cntr-1].Options);
      end;
    {od for}
    if MemoBlock > 0 then begin
      edMSize.Text := IntToStr(MemoBlock);
      Panel1.Visible := True;
      end
    else
      Panel1.Visible := False;
    {fi}
    end;
  {od with}
end;

procedure TFormStruct.btnPrintClick(Sender: TObject);
begin
  MainForm.PrintStruct(TMDIChild(MainForm.ActiveMDIChild),True,True);
end;

procedure TFormStruct.btnSaveClick(Sender: TObject);
begin
  MainForm.SaveStruct(TMDIChild(MainForm.ActiveMDIChild),True,True);
end;

end.
